//+------------------------------------------------------------------+
//|                                                  MACDofHA_v1.mq4 |
//|                           Copyright  2007, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers 2
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_width1  2
//----
extern int Price        =  0;
extern int FastMA       =  8;
extern int FastMAMode   =  1;
extern int SlowMA       = 21;
extern int SlowMAMode   =  1;
extern int SignalMA     =  5;
extern int SignalMAMode =  1;

//---- buffers
double haMACD[];
double haSignal[];
double haClose[];
double haOpen[];
double haHigh[];
double haLow[];
double haPrice[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
{
//---- indicators
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(0,haMACD);
   SetIndexBuffer(1,haSignal);
   SetIndexBuffer(2,haClose);
   SetIndexBuffer(3,haOpen);
   SetIndexBuffer(4,haHigh);
   SetIndexBuffer(5,haLow);
   SetIndexBuffer(6,haPrice);
//----
   string short_name="MACDofHA("+Price+","+FastMA+","+SlowMA+","+SignalMA+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");  
   SetIndexDrawBegin(0,SlowMA+FastMA+SignalMA);
   SetIndexDrawBegin(1,SlowMA+FastMA+SignalMA);
    
//---- initialization done
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int shift, limit, counted_bars=IndicatorCounted();
   
   
   if (Bars-1<SlowMA)return(0);
   if (counted_bars<0)return(-1);
   if (counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars-1; 
      
   for( shift=limit; shift>=0; shift--)
   {
   haOpen[shift]=(haOpen[shift+1]+haClose[shift+1])/2.0;
   haClose[shift]=(Open[shift]+High[shift]+Low[shift]+Close[shift])/4;
   haHigh[shift]=MathMax(High[shift], MathMax(haOpen[shift], haClose[shift]));
   haLow[shift]=MathMin(Low[shift], MathMin(haOpen[shift], haClose[shift]));
   
      if(Price==0) haPrice[shift] = haClose[shift];
      else
      if(Price==1) haPrice[shift] = haOpen[shift];
      else
      if(Price==2) haPrice[shift] = haHigh[shift];
      else
      if(Price==3) haPrice[shift] = haLow[shift];
      else
      if(Price==4) haPrice[shift] = (haHigh[shift]+haLow[shift])/2;
      else
      if(Price==5) haPrice[shift] = (haHigh[shift]+haLow[shift]+haClose[shift])/3;
      else
      if(Price==6) haPrice[shift] = (haHigh[shift]+haLow[shift]+2*haClose[shift])/4;
      else
      haPrice[shift] = haClose[shift];
   }
   
   for( shift=limit; shift>=0; shift--)
   haMACD[shift] = iMAOnArray(haPrice,0,FastMA,0,FastMAMode,shift) - iMAOnArray(haPrice,0,SlowMA,0,SlowMAMode,shift); 
   
   for( shift=limit; shift>=0; shift--)
   haSignal[shift] = iMAOnArray(haMACD,0,SignalMA,0,SignalMAMode,shift);
//----
   return(0);
  }
//+------------------------------------------------------------------+